<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TopicSearch StructType
 * @subpackage Structs
 */
class TopicSearch extends SearchRecord
{
    /**
     * The basic
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\TopicSearchBasic
     */
    public $basic;
    /**
     * The solutionJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SolutionSearchBasic
     */
    public $solutionJoin;
    /**
     * The userJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\EmployeeSearchBasic
     */
    public $userJoin;
    /**
     * Constructor method for TopicSearch
     * @uses TopicSearch::setBasic()
     * @uses TopicSearch::setSolutionJoin()
     * @uses TopicSearch::setUserJoin()
     * @param \StructType\TopicSearchBasic $basic
     * @param \StructType\SolutionSearchBasic $solutionJoin
     * @param \StructType\EmployeeSearchBasic $userJoin
     */
    public function __construct(\StructType\TopicSearchBasic $basic = null, \StructType\SolutionSearchBasic $solutionJoin = null, \StructType\EmployeeSearchBasic $userJoin = null)
    {
        $this
            ->setBasic($basic)
            ->setSolutionJoin($solutionJoin)
            ->setUserJoin($userJoin);
    }
    /**
     * Get basic value
     * @return \StructType\TopicSearchBasic|null
     */
    public function getBasic()
    {
        return $this->basic;
    }
    /**
     * Set basic value
     * @param \StructType\TopicSearchBasic $basic
     * @return \StructType\TopicSearch
     */
    public function setBasic(\StructType\TopicSearchBasic $basic = null)
    {
        $this->basic = $basic;
        return $this;
    }
    /**
     * Get solutionJoin value
     * @return \StructType\SolutionSearchBasic|null
     */
    public function getSolutionJoin()
    {
        return $this->solutionJoin;
    }
    /**
     * Set solutionJoin value
     * @param \StructType\SolutionSearchBasic $solutionJoin
     * @return \StructType\TopicSearch
     */
    public function setSolutionJoin(\StructType\SolutionSearchBasic $solutionJoin = null)
    {
        $this->solutionJoin = $solutionJoin;
        return $this;
    }
    /**
     * Get userJoin value
     * @return \StructType\EmployeeSearchBasic|null
     */
    public function getUserJoin()
    {
        return $this->userJoin;
    }
    /**
     * Set userJoin value
     * @param \StructType\EmployeeSearchBasic $userJoin
     * @return \StructType\TopicSearch
     */
    public function setUserJoin(\StructType\EmployeeSearchBasic $userJoin = null)
    {
        $this->userJoin = $userJoin;
        return $this;
    }
}
